// Copyright (C) 2008-2009 - INRIA - Michael Baudin
//
// This file must be used under the terms of the CeCILL.
// This source file is licensed as described in the file COPYING, which
// you should have received as part of this distribution.  The terms
// are also available at
// http://www.cecill.info/licences/Licence_CeCILL_V2-en.txt

function value = assert_cget (key)
  //   Quiery the value of configurable options.
  //
  // Calling Sequence
  //   value = assert_cget (key)
  //
  // Parameters
  //   key: a string, the option to quiery. 
  //   value: the value of the option.
  //
  // Description
  //   The list of available keys is key = "-verbose", "-relativeprecision", "-absoluteprecision", 
  //   "-errorfunction", "-compnorm", "-erroronfail"
  //
  // Authors
  //   Michael Baudin, 2010

  global %assert
  select key
  case "-verbose" then
    value = %assert.verbose
  case "-relativeprecision" then
    value = %assert.relativeprecision
  case "-absoluteprecision" then
    value = %assert.absoluteprecision
  case "-errorfunction" then
    value = %assert.errorfunction
  case "-compnorm" then
    value = %assert.compnorm
  case "-erroronfail" then
    value = %assert.erroronfail
  else
    errmsg = sprintf( gettext ( "%s: Unknown key %s" ) , "assert_cget" , key )
    error(errmsg)
  end
endfunction

