// Copyright (C) 2008-2009 - INRIA - Michael Baudin
//
// This file must be used under the terms of the CeCILL.
// This source file is licensed as described in the file COPYING, which
// you should have received as part of this distribution.  The terms
// are also available at
// http://www.cecill.info/licences/Licence_CeCILL_V2-en.txt

function assert_configure ( key , value )
  // Configure the assert module.
  //
  // Calling Sequence
  //   assert_configure ( key , value )
  //
  // Parameters
  //   key: a string, the option to quiery. 
  //   value: the value of the option.
  //
  // Description
  //   
  //
  // Authors
  //   Michael Baudin, 2010

  global %assert
  select key
  case "-verbose" then
    %assert.verbose = value
  case "-relativeprecision" then
    if ( value < 0. ) then
    errmsg = sprintf( gettext ( "%s: Relative precision is negative: %e" ) ,"assert_configure" , value )
    error(errmsg)
    end
    %assert.relativeprecision = value
  case "-absoluteprecision" then
    if ( value < 0. ) then
    errmsg = sprintf( gettext ( "%s: Absolute precision is negative: %e") ,"assert_configure" , value )
    error(errmsg)
    end
    %assert.absoluteprecision = value
  case "-errorfunction" then
    %assert.errorfunction = value
  case "-compnorm" then
    // TODO : check for comparison norm consistency
    %assert.compnorm = value
  case "-erroronfail" then
    %assert.erroronfail = value
  else
    errmsg = sprintf( gettext ( "%s: Unknown key %s" ) , "assert_configure" , key )
    error(errmsg)
  end
endfunction


