// Copyright (C) 2008-2009 - INRIA - Michael Baudin
//
// This file must be used under the terms of the CeCILL.
// This source file is licensed as described in the file COPYING, which
// you should have received as part of this distribution.  The terms
// are also available at
// http://www.cecill.info/licences/Licence_CeCILL_V2-en.txt

function value = assert_get (key)
  //
  //   Retrieve a field of the assert module.
  //
  // Calling sequence
  //   value = assert_get (key)
  //
  // Description
  //   Quiery a non-configurable field.
  //
  //
  // Authors
  //   Michael Baudin, 2010

  global %assert
  select key
  case "-total" then
    value = %assert.total
  case "-failed" then
    value = %assert.failed
  case "-passed" then
    value = %assert.passed
  else
    errmsg = sprintf( gettext ( "%s: Unknown key %s" ) , "assert_cget" , key )
    error(errmsg)
  end
endfunction

