// Copyright (C) 2008-2009 - INRIA - Michael Baudin
//
// This file must be used under the terms of the CeCILL.
// This source file is licensed as described in the file COPYING, which
// you should have received as part of this distribution.  The terms
// are also available at
// http://www.cecill.info/licences/Licence_CeCILL_V2-en.txt

function assert_startup ( )
  //   Startup the assert library.
  //
  // Calling Sequence
  //   assert_startup ( )
  //
  // Description
  //   Initialize the global variable %assert which is used in this module.
  //   TODO : avoid global parameter for parallel execution of unit tests
  //
  // Authors
  //   Michael Baudin, 2010
  
  global %assert
  %assert = tlist(["ASSERT"
    "relativeprecision"
    "absoluteprecision"
    "errorfunction"
    "compnorm"
    "failed"
    "passed"
    "total"
    "verbose"
    "erroronfail"
    ])
  %assert.relativeprecision = %eps
  %assert.absoluteprecision = 0.
  %assert.errorfunction = []
  %assert.compnorm = 2
  %assert.erroronfail = %t
  %assert.verbose = 0
  // Non-configurable fields
  %assert.failed = 0
  %assert.passed = 0
  %assert.total = 0
endfunction

