//
// This help file was automatically generated from assert_csvread.sci using help_from_sci().
// PLEASE DO NOT EDIT
//
mode(1)
//
// Demo of assert_csvread.sci
//

// Define a matrix of strings
Astr = [
"1" "8" "15" "22" "29" "36" "43" "50"
"2" "9" "16" "23" "30" "37" "44" "51"
"3" "10" "17" "6+3*I" "31" "38" "45" "52"
"4" "11" "18" "25" "32" "39" "46" "53"
"5" "12" "19" "26" "33" "40" "47" "54"
"6" "13" "20" "27" "34" "41" "48" "55"
"+0" "-0" "Inf" "-Inf" "Nan" "1.D+308" "1.e-308" "1.e-323"
];
halt()   // Press return to continue
 
// Create a file with some data separated with commas
srcstring = fullfile(TMPDIR , 'foo.csv');
sep = ",";
fd = mopen(srcstring,'wt');
for i = 1 : size(Astr,"r")
mfprintf(fd,"%s\n",strcat(Astr(i,:),sep));
end
mclose(fd);
// To see the file : edit(srcstring)
halt()   // Press return to continue
 
// Read this file
Bstr = assert_csvread ( srcstring )
// To convert this data into a double :
Bdbl = evstr(Bstr)
halt()   // Press return to continue
 
// Create a file with a particular separator: here ";"
srcstring = fullfile(TMPDIR , 'foo.csv');
sep = ";";
fd = mopen(srcstring,'wt');
for i = 1 : size(Astr,"r")
mfprintf(fd,"%s\n",strcat(Astr(i,:),sep));
end
mclose(fd);
//
// Read the file and customize the separator
assert_csvread ( srcstring , sep )
halt()   // Press return to continue
 
// Create a file with comments
srcstring = fullfile(TMPDIR , 'foo.csv');
sep = ",";
fd = mopen(srcstring,'wt');
mfprintf(fd,"#This is a comment\n");
for i = 1 : size(Astr,"r")
mfprintf(fd,"%s\n",strcat(Astr(i,:),sep));
mfprintf(fd,"# This is another comment\n");
end
mfprintf(fd,"# This is a final comment\n");
mclose(fd);
//
// Read the file and ignore the comments
assert_csvread ( srcstring )
// Customize the comment regular expression
assert_csvread ( srcstring , [] , [] , "/#(.*)/" )
halt()   // Press return to continue
 
halt()   // Press return to continue
 
// Create a data file with particular Infinities and complex numbers
Astr = [
"6+3*I" "13-7*I" "20+4*I" "27-1.5*I" "34+3.14*I" "41-3*I" "48+3*I" "55-7*I"
"+0" "-0" "Infinity" "-Infinity" "Nan" "1.D+308" "1.e-308" "1.e-323"
];
expected = [
"6+3*%i" "13-7*%i" "20+4*%i" "27-1.5*%i" "34+3.14*%i" "41-3*%i" "48+3*%i" "55-7*%i"
"+0" "-0" "%inf" "-%inf" "%nan" "1.D+308" "1.e-308" "1.e-323"
];
filename = fullfile(TMPDIR , "foo.csv");
sep = ",";
fd = mopen(filename,'wt');
for i = 1 : size(Astr,"r")
mfprintf(fd,"%s\n",strcat(Astr(i,:),sep));
end
mclose(fd);
//
// Customize the replace map.
replacemap=["Nan","%nan";"Infinity","%inf";"I","%i"];
assert_csvread ( filename , [] , [] , [] , [] , replacemap )
halt()   // Press return to continue
 
// Configure the decimal mark.
Atext = [
" 1,000000000D+00; 0,000000000D+00; 2,000000000D+02;             Inf; 0,000000000D+00";
" 1,000000000D+00; 1,00000000D-300; 2,000000000D+02;             Inf; 0,000000000D+00";
" 1,000000000D+00; 1,00000000D-200; 2,000000000D+02; 3,15000000D+300; 1,020000000D+02";
" 9,999999999D-01; 1,00000000D-100; 2,000000000D+02; 2,960000000D+02; 1,170000000D+02";
" 1,000000000D+00;             Inf;            -Inf;             Nan; 0,000000000D+00"
];
assert_csvread ( Atext , ";" , "," , [] , %t )
halt()   // Press return to continue
 
// Check that datasetread and datasetwrite are inverse.
A = rand(3,4)+rand(3,4)*%i
Astr = assert_csvwrite(A);
Bstr = assert_csvread(Astr,[],[],[],%t);
B = evstr(Bstr);
and(A==B)
halt()   // Press return to continue
 
// Read a data with an inconsistent number of columns
Atxt=[
"40 5 30 1.6 0.2 1.2"
"15 25 35 0.6 1 1.4"
"20 45 10 0.8 1.8 0.4"
""
"2.6667 0.33333 2"
"1 1.6667 2.3333"
"1.3333 3 0.66667"
];
A = assert_csvread ( Atxt," ",[],[],%t )
// Read a file with an unconsistent number of columns
Atxt=[
"2.6667 0.33333 2"
"1 1.6667 2.3333"
"1.3333 3 0.66667"
""
"40 5 30 1.6 0.2 1.2"
"15 25 35 0.6 1 1.4"
"20 45 10 0.8 1.8 0.4"
];
A = assert_csvread ( Atxt," ",[],[],%t )
halt()   // Press return to continue
 
// Read data and convert into doubles
Astr = [
"1,8,15,22,29,36,43,50"
"2,9,16,23,30,37,44,51"
"3,10,17,6+3*I,31,38,45,52"
"4,11,18,25,32,39,46,53"
"5,12,19,26,33,40,47,54"
"6,13,20,27,34,41,48,55"
"+0,-0,Inf,-Inf,Nan,1.D+308,1.e-308,1.e-323"
];
A = assert_csvread ( Astr,[],[],[],%t,[],2 )
halt()   // Press return to continue
 
// Read only rows/columns in range
Astr = [
"1,8,15,22,29,36,43,50"
"2,9,16,23,30,37,44,51"
"3,10,17,6+3*I,31,38,45,52"
"4,11,18,25,32,39,46,53"
"5,12,19,26,33,40,47,54"
"6,13,20,27,34,41,48,55"
"+0,-0,Inf,-Inf,Nan,1.D+308,1.e-308,1.e-323"
];
A = assert_csvread ( Astr,[],[],[],%t,[],[],[2 3 5 6] );
halt()   // Press return to continue
 
// The irange argument allows to read large datasets.
// In the following example, we read only the last line of a large dataset.
n=50;
M = ones(n, n);
filename=fullfile(TMPDIR,"foo.csv");
assert_csvwrite(M,filename);
assert_csvread(filename);
Mlast = assert_csvread ( filename , [] , [] , [] , [] , [] , [] , [n 1 n n] );
halt()   // Press return to continue
 
//
// We create a "large" csv file with 10 000 rows and 3 columns.
filename=fullfile(TMPDIR,"prices.csv");
fd = mopen(filename,"w");
for i= 1:10000
mputl("02/05/10 00:00:02,1.32453,1.32491",fd);
end
mclose(fd);
//
// We read it by blocks of 1234 rows and end the read when the
// end of the file is reached.
blocksize = 1234;
C1 = 1;
C2 = 3;
iblock = 1
while (%t)
R1 = (iblock-1) * blocksize + 1;
R2 = blocksize + R1-1;
irange = [R1 C1 R2 C2];
M=assert_csvread(filename , [] , [] , [] , [] , [] , [] , irange );
nrows = size(M,"r");
disp([iblock R1 R2 nrows])
if ( nrows < blocksize ) then
break
end
iblock = iblock + 1;
end
halt()   // Press return to continue
 
//========= E N D === O F === D E M O =========//
//
// Load this script into the editor
//
filename = "assert_csvread.sce";
dname = get_absolute_file_path(filename);
editor ( fullfile(dname,filename) );
